rm(list = ls())
library(Hmisc)
library(car)
library(rms)
library(pROC)
library(rmda)
data_dir <- choose.dir(default = "D:\\data_dir", caption = "XXX")
output_dir <- choose.dir(default = "D:\\output_dir", caption = "XXX")
training_dataset_path <- choose.files(default = data_dir, caption = "XXX", multi = TRUE, filters = Filters, index = nrow(Filters))
training_dataset<- read.csv(training_dataset_path, header = TRUE,sep="\t", stringsAsFactors=FALSE)
View(training_dataset) 
str(training_dataset)
training_dataset$Gender<-factor(training_dataset$Gender,levels=c(0,1),
                                labels=c("0","1"))
training_dataset$Manual_laborers<-factor(training_dataset$Manual_laborers, levels=c(0,1),
                                         labels=c("No","Yes"))
training_dataset$Education_Level <-factor(training_dataset$Education_Level,levels=c(1,2,3),
                                          labels=c("1","2","3"))
training_dataset$Smooking<-factor(training_dataset$Smooking,levels=c(0,1),
                                  labels=c("No","Yes"))
training_dataset$Drinking<-factor(training_dataset$Drinking,levels=c(0,1),
                                  labels=c("No","Yes"))
View(training_dataset) 
str(training_dataset) 
validation_dataset_path <- choose.files(default = data_dir, caption = "XXX", multi = TRUE, filters = Filters, index = nrow(Filters))
validation_dataset<- read.csv(validation_dataset_path, header = TRUE,sep="\t", stringsAsFactors=FALSE)
View(validation_dataset) 
str(validation_dataset) 
validation_dataset$Gender<-factor(validation_dataset$Gender,levels=c(0,1),
                                  labels=c("0","1"))
validation_dataset$Manual_laborers<-factor(validation_dataset$Manual_laborers, levels=c(0,1),
                                           labels=c("0","1"))
validation_dataset$Education_Level <-factor(validation_dataset$Education_Level,levels=c(1,2,3),
                                            labels=c("1","2","3"))
validation_dataset$Smooking<-factor(validation_dataset$Smooking,levels=c(0,1),
                                    labels=c("No","Yes"))
validation_dataset$Drinking<-factor(validation_dataset$Drinking,levels=c(0,1),
                                    labels=c("No","Yes"))
View(validation_dataset)
str(validation_dataset) 
com_type="btw_datasets"
var_name="Gender"
comparison_nomogram<-function(com_type,training_dataset,validation_dataset,var_name,var_type){
  if(com_type=="btw_datasets"){
    data_1=training_dataset[,var_name]
    data_2=validation_dataset[,var_name]
  }else if(com_type=="btw_grp"){
    data_1=training_dataset[(training_dataset[,1]==0),var_name]
    data_2=training_dataset[(training_dataset[,1]==1),var_name]
  }
  if(var_type=="continue_type"){
    judge_p<-function(p1,p2,p3,tp,zhp){
      mark<-0
      if(p1<0.05){
        mark<-1
      }
      if(p2<0.05){
        mark<-1
      }
      if(p3<0.05){
        mark<-1
      }
      if(mark==0){
        return(tp)
      }else{
        return(zhp)
      }
    }
    grp_1_ztp<-shapiro.test(data_1)[2][[1]]
    grp_2_ztp<-shapiro.test(data_2)[2][[1]]
    y_leveneT=c(data_1, data_2)
    group_leveneT=as.factor(c(rep(1,length(data_1)), rep(2,length(data_2))))
    fcp<-leveneTest(y_leveneT,group_leveneT)[3][[1]][1]
    t_testp<-t.test(data_1,data_2,paired=F)[3][[1]]
    df = data.frame(y_leveneT,group_leveneT)
    zhp<-wilcox.test(y_leveneT~group_leveneT, df)[3][[1]]
    finalp<-judge_p(p1=grp_1_ztp, p2=grp_2_ztp, p3=fcp, tp=t_testp, zhp=zhp)
  }else if(var_type=="bi_type"){
    col_matrix_producer<-function(grp_0_dingxing_data,grp_1_dingxing_data){
      vars<-unique(c(names(table(grp_0_dingxing_data)),names(table(grp_1_dingxing_data))))
      col_matrix<-matrix(data = 0, nrow = length(vars), ncol = 2, byrow = FALSE,dimnames = NULL)
      colnames(col_matrix)<-c("grp_0","grp_1")
      rownames(col_matrix)<-vars
      for(index_var in 1:length(vars)){
        if(!is.na(table(grp_0_dingxing_data)[vars[index_var]][[1]])){
          col_matrix[vars[index_var],"grp_0"]<-table(grp_0_dingxing_data)[vars[index_var]][[1]]
        }
      }
      for(index_var in 1:length(vars)){
        if(!is.na(table(grp_1_dingxing_data)[vars[index_var]][[1]])){
          col_matrix[vars[index_var],"grp_1"]<-table(grp_1_dingxing_data)[vars[index_var]][[1]]
        }
      }
      return(col_matrix)
    }
    col_matrix_ratio_producer<-function(col_matrix, round_num){
      out_table<-col_matrix
      for(index_col in 1:ncol(col_matrix)){
        sum_col<-sum(col_matrix[,index_col])
        for(index_row in 1:nrow(col_matrix)){
          ratio<-round(100*col_matrix[index_row,index_col]/sum_col, round_num)
          out_table[index_row,index_col]<-paste0(col_matrix[index_row,index_col], " (",ratio,"%)")
        }
      }
      return(out_table)
    }
    b0 = which(data_1=="NA")
    if(length(b0)){
      data_1<-data_1[-b0]
    }
    b1 = which(data_2=="NA")
    if(length(b1)){
      data_2<-data_2[-b1]
    }
    col_matrix<-col_matrix_producer(data_1,data_2)
    chisqcp<-chisq.test(col_matrix)[3][[1]]
    fisherp<- tryCatch(fisher.test(col_matrix)[1][[1]],error=function(e){return("A")} )
    if(fisherp=="A"){           
      fisherp<-fisher.test(col_matrix,simulate.p.value=TRUE)[1][[1]]
      
    }
    #fisherp<-fisher.test(col_matrix)[1][[1]]
    col_matrix_observed<-chisq.test(col_matrix)$observed
    col_matrix_expected<-chisq.test(col_matrix)$expected
    round_num<-1
    col_matrix_ratio<-col_matrix_ratio_producer(col_matrix, round_num)
    
    sum_N<-sum(col_matrix)
    
    if(any(col_matrix_expected<5) | sum_N<40){
      finalp<-fisherp
    }else{
      finalp<-chisqcp
    }
  }
  return(paste0("XX",var_name,"XX",finalp))
  
}

com_type="btw_datasets"

var_name = "Age"

var_type = "continue_type"

comparison_nomogram(com_type=com_type,
                    training_dataset=training_dataset,
                    validation_dataset=validation_dataset,
                    var_name=var_name,
                    var_type=var_type)


com_type="btw_grp"

var_name = "Age"

var_type = "continue_type"

comparison_nomogram(com_type=com_type,
                    training_dataset=training_dataset,
                    validation_dataset=validation_dataset,
                    var_name=var_name,
                    var_type=var_type)


ddist <- datadist(training_dataset)
options(datadist='ddist')

f_lrm <-lrm(OP ~ Age, data=training_dataset, x=TRUE, y=TRUE,maxit=1000)

print(f_lrm)

ddist <- datadist(training_dataset)
options(datadist='ddist')
f_lrm <-lrm(OP ~ Gender+Education_Level+Weight, data=training_dataset, x=TRUE, y=TRUE,maxit=1000)

print(f_lrm)


C_index <- rcorrcens(training_dataset$OP~predict(f_lrm))
se<-C_index[4]/2#SD
ul<-C_index[1]+1.96*se
dl<-C_index[1]-1.96*se
print(paste0("C指数及其可信区间为：",C_index[1]," (",dl,", ",ul,")"))

ddist <- datadist(training_dataset)
options(datadist='ddist')

pdf(file=paste(output_dir, "\\nomogram.pdf", sep = ""),width=10,height=10) 
nomogram <- nomogram(f_lrm,fun=function(x)1/(1+exp(-x)), 
                     fun.at = c(0.01,0.1,0.3,0.5,0.8,0.9,0.99),
                     funlabel = "Probability of Osteoporosis", 
                     lp=F, 
                     conf.int = F, 
                     abbrev = F
)

plot(nomogram)
dev.off()


pred_f_training<-predict(f_lrm,training_dataset)
pred_f_training<-1/(1+exp(-pred_f_training))

modelroc <- roc(training_dataset$OP, pred_f_training,ci = TRUE)

pdf(file=paste(output_dir, "\\ROC_training.pdf", sep = ""),width=10,height=10) 
plot(modelroc, print.auc=TRUE, auc.polygon=TRUE, auc.polygon.col="skyblue", grid=c(0.1, 0.2),
     print.thres=TRUE,  smooth=TRUE)
dev.off()

pred_f_validation<-predict(f_lrm,validation_dataset)
pred_f_validation<-1/(1+exp(-pred_f_validation))

modelroc <- roc(validation_dataset$OP,pred_f_validation,ci = TRUE)

pdf(file=paste(output_dir, "\\ROC_testing.pdf", sep = ""),width=10,height=10) 
plot(modelroc, print.auc=TRUE, auc.polygon=TRUE, auc.polygon.col="skyblue", grid=c(0.1, 0.2),
     print.thres=TRUE,  smooth=TRUE)
dev.off()

cal <- calibrate(f_lrm,predy=seq(0, 1.0, length=50),B=1000)#method=c("boot","crossvalidation",".632","randomization")
pdf(file=paste(output_dir, "\\calibrate_training.pdf", sep = ""),width=10,height=10) 
plot(cal)
dev.off()

fit.vad<-lrm(validation_dataset$OP~pred_f_validation,data=validation_dataset,x=T,y=T)

pdf(file=paste(output_dir, "\\calibrate_testing.pdf", sep = ""),width=10,height=10) 
cal <- calibrate(fit.vad,predy=seq(0, 1, length=50),B=1000)#method=c("boot","crossvalidation",".632","randomization")
plot(cal)
dev.off()

pdf(file=paste(output_dir, "\\DCA_training.pdf", sep = ""),width=10,height=10) 


DCA_training<- decision_curve(OP ~ Gender+Education_Level+Weight, data = training_dataset
                              #,policy = "opt-in"
                              ,study.design = 'cohort')
plot_decision_curve(DCA_training,curve.names= c('Nomogram model'), confidence.intervals=FALSE)
dev.off()

pdf(file=paste(output_dir, "\\training_clinical_impact.pdf", sep = ""),width=10,height=10) 

plot_clinical_impact(DCA_training, population.size= 1000,
                     cost.benefit.axis = T,
                     n.cost.benefits= 6,
                     col =c('red','blue'),
                     confidence.intervals= T,
                     ylim=c(0,1000),
                     legend.position="topright")
dev.off()

incidence_rate_training_dataset<-table(training_dataset$OP)["1"][[1]]/(table(training_dataset$OP)["0"][[1]]+table(training_dataset$OP)["1"][[1]])
all_line<-1-(DCA_training$derived.data$thresholds)/incidence_rate_training_dataset

data.frame("thresholds" = DCA_training$derived.data$thresholds,"sNB" = DCA_training$derived.data$sNB,"All_line" = all_line)[c(0:100),]

pdf(file=paste(output_dir, "\\DCA_testing.pdf", sep = ""),width=10,height=10) 
DCA_validation<- decision_curve(OP ~ Gender+Education_Level+Weight, data = validation_dataset
                                #,policy = "opt-in"
                                ,study.design = 'cohort')
plot_decision_curve(DCA_validation,curve.names= c('Nomogram model'), confidence.intervals=FALSE)
dev.off()

pdf(file=paste(output_dir, "\\validation_clinical_impact.pdf", sep = ""),width=10,height=10) 

plot_clinical_impact(DCA_validation, population.size= 1000,
                     cost.benefit.axis = T,
                     n.cost.benefits= 6,
                     col =c('red','blue'),
                     confidence.intervals= T,
                     ylim=c(0,1000),
                     legend.position="topright")
dev.off()

incidence_rate_validation_dataset<-table(validation_dataset$OP)["1"][[1]]/(table(validation_dataset$OP)["0"][[1]]+table(validation_dataset$OP)["1"][[1]])

all_line<-1-(DCA_validation$derived.data$thresholds)/incidence_rate_validation_dataset

data.frame("thresholds" = DCA_validation$derived.data$thresholds,"sNB" = DCA_training$derived.data$sNB,"All_line" = all_line)[c(0:100),]



library(regplot)
setwd("C:/Users/Lin/Desktop/zuizhong/liexian")

fit2 <- lrm(OP ~ Gender+Education_Level+Weight, data=training_dataset,x=T,y=T)
regplot(fit2, plots = c("violin", "bars"), 
        observation = training_dataset[5,], 
        center = T, 
        subticks = T,
        droplines = T,
        title = "nomogram",
        points = T, 
        odds = F, 
        showP = T, 
        rank = "sd", 
        interval="confidence", 
        clickable = F 
)


setwd("C:/Users/Lin/Desktop/zuizhong/liexian")

getwd()

library(DynNom)

fit2 <- glm(OP ~ Gender+Education_Level+Weight, data=training_dataset, family = binomial)

DNbuilder(fit2,data = training_dataset,
          clevel = 0.95)

DynNom(fit2, clevel = 0.95, DNtitle = "Dynamic Nomogram", DNxlab = "Probability of Osteoporosis")





